/*
    atti_esti Task
    atti_esti任务
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "bsp/pwm.h" 
#include "component/ahrs.h" 
#include "component/pid.h" 
#include "device/bmi088.h" 
#include "module/gimbal.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
BMI088_t bmi088; 
AHRS_t gimbal_ahrs; 
AHRS_Magn_t magn; 
AHRS_Eulr_t eulr_to_send; 
KPID_t imu_temp_ctrl_pid; 
Gimbal_IMU_t gimbal_to_send;
BMI088_Cali_t cali_bmi088= { .gyro_offset = {0.0f,0.0f,0.0f}, };
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_atti_esti(void *argument) {
   (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
    const uint32_t delay_tick = osKernelGetTickFreq() / ATTI_ESTI_FREQ;

    osDelay(ATTI_ESTI_INIT_DELAY); /* 延时一段时间再开启任务 */

    uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
    BMI088_Init(&bmi088,&cali_bmi088);
    AHRS_Init(&gimbal_ahrs, &magn, BMI088_GetUpdateFreq(&bmi088));
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
    BMI088_WaitNew(); 
		BMI088_AcclStartDmaRecv();
		BMI088_AcclWaitDmaCplt();
		BMI088_GyroStartDmaRecv();
		BMI088_GyroWaitDmaCplt(); 
		/* 锁住RTOS内核防止数据解析过程中断，造成错误 */
		osKernelLock(); 
		/* 接收完所有数据后，把数据从原始字节加工成方便计算的数据 */
		BMI088_ParseAccl(&bmi088);
		BMI088_ParseGyro(&bmi088); 
		// IST8310_Parse(&ist8310);
		/* 根据设备接收到的数据进行姿态解析 */
		AHRS_Update(&gimbal_ahrs, &bmi088.accl, &bmi088.gyro, &magn); 
		/* 根据解析出来的四元数计算欧拉角 */
		AHRS_GetEulr(&eulr_to_send, &gimbal_ahrs);
		osKernelUnlock();
		gimbal_to_send.eulr = eulr_to_send;
		gimbal_to_send.gyro = bmi088.gyro; 
		osMessageQueueReset(task_runtime.msgq.gimbal.imu); 
		osMessageQueuePut(task_runtime.msgq.gimbal.imu, &gimbal_to_send, 0, 0);
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}